<?php
/*
	Plugin Name: BBQ Firewall Whitelist
	Plugin URI: http://perishablepress.com/bbq-whitelist-blacklist/
	Description: Remove patterns from BBQ Firewall rules.
	Author: Jeff Starr
	Author URI: https://monzillamedia.com/
	Donate link: http://m0n.co/donate
	Requires at least: 5.1
	Tested up to: 6.2
	Version: 2.2
	License: GPL v2 or later
*/

if (!defined('ABSPATH')) die();


// add new patterns here

$bbq_whitelist_request_uri_items  = array();
$bbq_whitelist_query_string_items = array('%0a');
$bbq_whitelist_user_agent_items   = array();
$bbq_whitelist_referrer_items     = array();
$bbq_whitelist_post_items         = array();


// no need to fiddle beyond this point

add_filter('request_uri_items',  'bbq_whitelist_request_uri_items',  10, 1);
add_filter('query_string_items', 'bbq_whitelist_query_string_items', 10, 1);
add_filter('user_agent_items',   'bbq_whitelist_user_agent_items',   10, 1);
add_filter('referrer_items',     'bbq_whitelist_referrer_items',     10, 1);
add_filter('post_items',         'bbq_whitelist_post_items',         10, 1);


function bbq_whitelist_request_uri_items($items) {
	global $bbq_whitelist_request_uri_items;
	$allowed = $bbq_whitelist_request_uri_items;
	foreach ($allowed as $allow) {
		$key = array_search($allow, $items);
		if (!empty($key)) unset($items[$key]);
	}
	return $items;
}

function bbq_whitelist_query_string_items($items) {
	global $bbq_whitelist_query_string_items;
	$allowed = $bbq_whitelist_query_string_items;
	foreach ($allowed as $allow) {
		$key = array_search($allow, $items);
		if (!empty($key)) unset($items[$key]);
	}
	return $items;
}

function bbq_whitelist_user_agent_items($items) {
	global $bbq_whitelist_user_agent_items;
	$allowed = $bbq_whitelist_user_agent_items;
	foreach ($allowed as $allow) {
		$key = array_search($allow, $items);
		if (!empty($key)) unset($items[$key]);
	}
	return $items;
}

function bbq_whitelist_referrer_items($items) {
	global $bbq_whitelist_referrer_items;
	$allowed = $bbq_whitelist_referrer_items;
	foreach ($allowed as $allow) {
		$key = array_search($allow, $items);
		if (!empty($key)) unset($items[$key]);
	}
	return $items;
}

function bbq_whitelist_post_items($items) {
	global $bbq_whitelist_post_items;
	$allowed = $bbq_whitelist_post_items;
	foreach ($allowed as $allow) {
		$key = array_search($allow, $items);
		if (!empty($key)) unset($items[$key]);
	}
	return $items;
}
